{$X+}

(*
                DOT-BO-GI 2.6.1 version for professional
                ----------------------------------------
                (c) KIM, JIN HONG (aromanix)


                      ---   History of DBG   ---

                        Born in someday of 1992
     The latest version of the old-age DBG was ended in 1994 by v1.90
            The newest new-age-tech version this was made up at
                        1995/11/30/Thu by v2.6.1


                          ---   NOTES   ---

          # This is free version
          # User can use the program freely without any permission
          # But, Never to be used as commercial
*)

uses
    option,dos,crt,screen;

const

     list_max           =       3500;           { maximum number of file }
     dbg_env_file       =       'DBG';          { common enviroment variable }
     dbg_assistant      =       'C:\_DBG_.BAT'; { common runing assistant file}
     dir_msg            =       ' Directory';
     r_sign             =       '/&';           { return sign by tab }

     { ciper codes of the version }
     version:array[1..80] of byte=($05,$0E,$15,$6C,$03,$0E,$6C,$06,$08,$61,
     $73,$6F,$77,$6F,$70,$61,$F2,$61,$69,$22,$68,$61,$70,$78,$78,$73,$6C,$70,
     $78,$78,$74,$61,$0A,$08,$0C,$6D,$61,$0B,$08,$0F,$61,$09,$0E,$0F,$06,$61,
     $69,$20,$33,$2E,$2C,$20,$2F,$28,$39,$68,$61,$61,$61,$61,$61,$61,$61,$61,
     $61,$61,$61,$61,$61,$61,$61,$61,$61,$61,$F2,$02,$0E,$13,$04,$00);

     monthdef:array[1..12] of string[3]=('Jan','Feb','Mar','Apr',
                 'May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');

     ext_max=26;               { maximum number of extension }
     ext_data:array[1..ext_max] of string[3]=(
     'EXE','COM','BAT','SYS','BAK','OLD','B~K','LZH','ARJ','ZIP',
     'OMP','ZOO','UC2','RAR','ICE','DOC','TXT','ME' ,'PAS','C'  ,
     'CPP','BAS','ASM','TMP','$$$','HWP');

     user_ext_max=255;

     run_     =     1;
     type_    =     2;
     del_     =     3;
     shell_   =     4;
     normal_  =     0;
     wide_    =     1;

type
        namelength         =       string[8];
        extlength          =       string[3];

        list_pointer       =       ^list_factor;  { pointer for record }
        list_factor        =       record
                                         name         :       namelength;
                                         ext          :       extlength;
                                         size,time    :       longint;
                                         num          :       word;
                                         attr,item,col:       byte;
                                         selected     :       boolean;
                                   end;

        list_variable      =       array[1..list_max] of list_pointer;

        option_variable    =       record
                                         func,   { 0:nothing 1:run 2:type 3:del 4:shell }
                                         view    : byte; { 0:normal  1:wide(four) 2:six }
                                         Pause_,Sub_,Exec_,Cust_     :            boolean;
                                   end;

        extrainfo_variable =       record
                                         exe_,com_,bat_,sys_,
                                         dir_,bak_,arc_,txt_,
                                         totalfilenum                :            word;

                                         totalfilesize,
                                         totaldisksize,diskfreesize  :          longint;
                                   end;

        user_ext_type      =       record
                                         ext:string[3];
                                         num:word;
                                   end;

        return_code_type   =       record
                                         it:word;
                                         y,idx:byte;
                                   end;

var
        user_ext_data:array[1..user_ext_max] of user_ext_type;
        user_ext_cnt:byte;

        opt                     :       option_variable;
        extrainfo               :       extrainfo_variable;
        wholepara,                              { whole parameter }
        viewer,                                 { viewer substitution }
        viewer_dest,
        viewer_option,                          { destination for viewer, option for viewer }
        compl_path                :              string;  { completed path   }

        l_scr,                                       { cursor Y location for scroll}
        c_scr                     :              byte;  { counter for scrolling line }

        oldexitproc               :              pointer;
        oldbreakstate             :              boolean;
        list                      :              list_variable;

        path                      :              dirstr;
        name                      :              namestr;
        exten                     :              extstr;
        tmpfilenum                :              longint;

        { MINI SHELL: it:word; y,idx:byte }
        r_code                    :              return_code_type;
        tab,r_tab                 :              boolean;
        exchange_tab_enter        :              boolean; { True, do as TAB key }

{$I c:\tp\product\dbg\dpublic.inc}

procedure AllDone;
begin
  blinkattrib(true);
  cursor(true);
  gotoxy(1,l_scr);
  setcbreak(oldbreakstate);
  exitproc:=oldexitproc;
  if opt.func=shell_ then fprint(spc(' ',80),1,25,7);
  halt;   { halt system }
end;

procedure Initvariables;
begin
  { common variables }
  fillchar(opt,sizeof(opt),0);                { reset all options to 0 and to false }
  fillchar(extrainfo,sizeof(extrainfo),0);    { reset all extra counters to 0 }

  l_scr               :=wherey;
  c_scr               :=0;

  { video }
  Scrn:=ptr(_DISPSEG,0); { used in ASK procedure at PUBLIC }
  blinkattrib(false);
  cursor(false);

  { system }
  oldexitproc   :=exitproc;
  exitproc      :=@AllDone;
  checkbreak    :=false;
  getcbreak(oldbreakstate);
  setcbreak(false);

  { minishell }
  user_ext_cnt        :=0;
  viewer              :='';
  tab                 :=false;
  r_tab               :=false;
  exchange_tab_enter  :=false;
end;

procedure help;
begin
  pr(decodever,1,_CT[15]+48,true);
  pr(spc('',80),1,_CT[8],true);
  pr('[Options]',1,_CT[11],false);
  pr('/? (/H) - Help',15,_CT[7],true);
  pr('/P      - Pause',15,_CT[7],true);
  pr('/W      - Wide display',15,_CT[7],true);
  pr('/C      - Custom display (not show HIDDEN, SYSTEM file)',15,_CT[7],true);
  pr('/S      - Search subdirectory',15,_CT[7],true);
  pr('/E      - display Executives only',15,_CT[7],true);
  pr('/:#     - Run #th file distinctively',15,_CT[7],true);
  pr('/D#     - Delete #th file',15,_CT[7],true);
  pr('/T#     - Type #th file',15,_CT[7],true);
  pr('/M      - MINI SHELL (will be separated)',15,_CT[7],true);
  pr('',1,0,true);
  pr('[Environment]',1,_CT[11],false);
  pr('SET DBG=[options] [pathname] [options]',15,_CT[7],true);
  pr(spc('',80),1,_CT[8],true);
  pr(' PRO-ORIENTED FREE-VERSION',1,_CT[7],true);
  pr(' You can use the program freely without any permission.',1,_CT[7],true);
  pr(' Please read DBGINFO.DOC for more information.',1,_CT[7],true);
  halt;
end;

procedure InitOption;
var t,l:byte;
    p,s:string;
begin
  wholepara:=ucase(eliminateblank(getparameters,true));

  p:=ucase(getenv(dbg_env_file));
  if p<>'' then wholepara:=wholepara+' '+p;

  l:=getoptionnum(wholepara);

  for t:=1 to l do begin
    p:=copy(getoption(wholepara,t),1,2);
    if p='/:' then opt.func:=run_;    { run distinctively }
    if p='/T' then opt.func:=type_;   { type }
    if p='/D' then opt.func:=del_;    { delete }
    if p='/M' then opt.func:=shell_;  { mini shell }
    if p='/W' then opt.view:=wide_;   { wide display }
    if p='/P' then opt.pause_:=true;  { pause }
    if p='/S' then opt.sub_:=true;    { search subdirectory }
    if p='/E' then opt.exec_:=true;   { executives only }
    if p='/C' then opt.cust_:=true;   { custom display }

    if (p='/?') or (p='/H') then help;

    if p=r_sign then begin
       s:=getfollow(wholepara,r_sign,false,true);
       if s<>'' then begin
          r_code.it:=str2num(getpath(s,1,false));
          r_code.y:=str2num(getpath(s,2,false));
          r_code.idx:=str2num(getpath(s,3,false));
          r_tab:=true;
       end;
       wholepara:=copy(wholepara,1,pos(r_sign,wholepara)-1);
    end;
  end;
end;

procedure volpath;
begin
  pr(getvolume(ord(compl_path[1])-64),1,_ct[15]+16,false);
  pr(compl_path,13,_CT[7],true);
  pr(spc('',80),1,_CT[8],true);
end;

procedure extrainfoview;
procedure sfp(s:string;n:longint;var nx:byte;c,f:byte;nf:boolean);
begin
  pr(s,nx,c,false);
  inc(nx,length(s));
  pr(num2str(n),nx,_CT[15],nf);
  inc(nx,f);
end;

var x:byte;
begin
  if extrainfo.totalfilenum=0 then pr('File not found.',1,_CT[7],true);

  pr(spc('',80),1,_CT[8],true);
  x:=1;
  sfp('EXE:',extrainfo.exe_,x,_CT[10],5,false);
  sfp('COM:',extrainfo.com_,x,_CT[10],5,false);
  sfp('BAT:',extrainfo.bat_,x,_CT[10],5,false);
  sfp('DIR:',extrainfo.dir_,x,_CT[9],5,false);
  sfp('SYS:',extrainfo.sys_,x,_CT[7],5,false);
  sfp('Text:',extrainfo.txt_,x,_CT[7],5,false);
  sfp('Arc:',extrainfo.arc_,x,_CT[7],5,false);
  sfp('Backup:',extrainfo.bak_,x,_CT[4],5,true);

  x:=1;
  sfp('File(s):',extrainfo.totalfilenum,x,_CT[7],7,false);
  x:=14;
  sfp('Total:',extrainfo.totalfilesize,x,_CT[7],12,false);
  pr(sizecf(extrainfo.totalfilesize),31,_CT[15],false);
  x:=39;
  sfp('Free:',extrainfo.diskfreesize,x,_CT[7],12,false);
  pr(sizecf(extrainfo.diskfreesize),55,_CT[15],false);
  pr(num2str(round(extrainfo.diskfreesize/extrainfo.totaldisksize*100))+'%',63,_CT[15],false);
  pr('Disk:',68,_CT[7],false);
  pr(sizecf(extrainfo.totaldisksize),73,_CT[15],true);
end;

procedure filelist_gathering(cp:string);
var t:word;
    w:byte;
    dir:searchrec;
begin
  if opt.cust_ then findfirst(cp,anyfile-volumeid-hidden-sysfile,dir)
  else              findfirst(cp,anyfile-volumeid,dir);

  { reset all extra counters to 0 without totaldisksize, diskfreesize }
  if opt.func=shell_ then fillchar(extrainfo,sizeof(extrainfo)-8,0);

  t:=0;
  while (doserror=0) and (t<list_max) do begin
    CheckESC;

    if (opt.exec_) and
       (pos('.EXE',dir.name)=0) and
       (pos('.COM',dir.name)=0) and
       (pos('.BAT',dir.name)=0) then begin
       findnext(dir);
       continue;
    end;

    inc(t);
    if list[t]=nil then new(list[t]);

    w:=pos('.',dir.name);

    if w<2 then begin { if non-pointer or dirname='.' or dirname='..' }
       list[t]^.name:=dir.name;
       list[t]^.ext:='';
    end else begin
             list[t]^.name:=copy(dir.name,1,w-1);
             list[t]^.ext:=copy(dir.name,w+1,length(dir.name)-w);
    end;

    list[t]^.size:=dir.size;
    list[t]^.attr:=dir.attr;
    list[t]^.time:=dir.time;
    inc(extrainfo.totalfilesize,dir.size);

    if dir.attr and directory=0 then whatkind(t)
    else list[t]^.item:=255; { 255 stands for DIR }

    list[t]^.col:=whatcolor(list[t]^.item);
    extrainfo_counter(list[t]^.item);

    findnext(dir);
  end;

  tmpfilenum:=t;
  inc(extrainfo.totalfilenum,t);
end;

procedure normalprint;
var t:word;
    c:byte;
    l:string;
    dt:datetime;
begin
  c:=c_scr;

  for t:=1 to tmpfilenum do begin
    CheckESC;

    { print file number }
    str(t:4,l);
    pr(l,1,_CT[7],false);

    { print file attrib }
    l:='----';
    if list[t]^.attr and readonly<>0 then l[1]:='r';
    if list[t]^.attr and hidden<>0 then l[2]:='h';
    if list[t]^.attr and sysfile<>0 then l[3]:='s';
    if list[t]^.attr and archive<>0 then l[4]:='a';
    pr(l,6,_CT[7],false);

    l:='            '; { 12 blanks }
    move(list[t]^.name[1],l[1],length(list[t]^.name));
    move(list[t]^.ext[1],l[10],length(list[t]^.ext));

    { print file name & extension }
    pr(l,11,list[t]^.col,false);

    { print file size, converted size }
    if list[t]^.item=255 then l:=dir_msg else str(list[t]^.size:10,l);
    pr(l+' ('+sizecf(list[t]^.size)+')',24,_CT[7],false);

    { print file date time }
    unpacktime(list[t]^.time,dt);
    pr(datecf(dt.year,dt.month,dt.day)+' '+
       timecf(dt.hour,dt.min),45,_CT[7],true);

    { turbo speed routine }
    if c<24 then inc(c) else c:=1;
    if (tmpfilenum-t>25) and (t>43) and (c=24) then l_scr:=1;
  end;
end;

procedure wideprint;
var t:word;
    x,c:byte;
    l:string;
begin
  x:=1;
  c:=c_scr;

  for t:=1 to tmpfilenum do begin
    CheckESC;

    l:='            '; { 12 blanks }
    move(list[t]^.name[1],l[1],length(list[t]^.name));
    move(list[t]^.ext[1],l[10],length(list[t]^.ext));

    { print file name & extension }
    pr(l,x,list[t]^.col,false);

    { print file size }
    pr(sizecf(list[t]^.size),x+12,_CT[7],false);

    inc(x,20);

    if t mod 4=0 then begin
       pr('',1,0,true);
       x:=1;
    end else pr('',x-1,_CT[8],false);

    { turbo speed routine }
    if c<100 then inc(c) else c:=1;
    if (tmpfilenum-t>100) and (t>172) and (c=100) then l_scr:=1;
  end;

  if t mod 4<>0 then pr('',1,0,true);
end;

procedure viewlist;
begin
  case opt.view of
    normal_:normalprint;
    wide_  :wideprint;
  end;
end;

procedure searchsubdir(p:string);
var d:searchrec;
begin
  findfirst(p+'\*.*',anyfile,d);

  while doserror=0 do begin
    CheckESC;

    if (d.attr and directory<>0) and (d.name<>'.') and (d.name<>'..') then begin
       pr(spc('',80),1,_CT[8],true);
       pr('CATALOG',1,_ct[7]+16,false);
       pr(p+'\'+d.name+'\'+name+exten,9,_CT[7],true);
       pr(spc('',80),1,_CT[8],true);

       filelist_gathering(p+'\'+d.name+'\'+name+exten);
       viewlist;
       searchsubdir(p+'\'+d.name);
    end;

    findnext(d);
  end;
end;

procedure Getdiskinfos;
begin
  { disk free & total size }
  extrainfo.diskfreesize:=diskfree(ord(compl_path[1])-64);
  extrainfo.totaldisksize:=disksize(ord(compl_path[1])-64);
end;

{$I c:\tp\product\dbg\dshell.inc}

begin
  initvariables;
  initoption;

  if opt.func=shell_ then analyze_initfile;

  compl_path:=completepath(getpath(wholepara,1,true));
  filelist_gathering(compl_path);

  case opt.func of
       del_  :deleter;
       type_ :typer;
       run_  :runfile;
       shell_:minishell;
  end;

  getdiskinfos;
  volpath;
  viewlist;

  if opt.sub_ then searchsubdir(copy(path,1,length(path)-1));
  extrainfoview;
end.
